#!/usr/bin/env node
"use strict";
/**
 * use-hoisted-version
 * Update lerna package to use hoisted version of npm dependency
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const trace_1 = require("@strong-roots-capital/trace");
const hoisted_packages_1 = require("@typescript-tools/hoisted-packages");
const io_ts_1 = require("@typescript-tools/io-ts");
const lerna_utils_1 = require("@typescript-tools/lerna-utils");
const monorepo_root_1 = require("@typescript-tools/monorepo-root");
const stringify_json_1 = require("@typescript-tools/stringify-json");
const debug_1 = __importDefault(require("debug"));
const fast_deep_equal_1 = __importDefault(require("fast-deep-equal"));
const Console = __importStar(require("fp-ts/Console"));
const E = __importStar(require("fp-ts/Either"));
const IO = __importStar(require("fp-ts/IO"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("fp-ts/Record"));
const T = __importStar(require("fp-ts/Task"));
const TE = __importStar(require("fp-ts/TaskEither"));
const function_1 = require("fp-ts/function");
const t = __importStar(require("io-ts"));
const D = __importStar(require("io-ts-docopt"));
const io_ts_docopt_1 = require("io-ts-docopt");
const PathReporter = __importStar(require("io-ts/lib/PathReporter"));
const shades_1 = require("shades");
const ts_pattern_1 = require("ts-pattern");
const debug = {
    cmd: (0, debug_1.default)('hoist'),
};
const docstring = `
Usage:
    use-hoisted-version <package>

Options:
    <package>    Path to package for which to update dependencies
`;
const CommandLineOptions = (0, io_ts_docopt_1.withEncode)(t.type({
    '<package>': t.string,
}), (a) => ({
    package: a['<package>'],
}));
// Widens the type of a particular Err into Err
const err = (error) => error;
const decodeDocopt = (0, function_1.flow)(D.decodeDocopt, E.mapLeft((error) => err({ type: 'docopt decode', error: PathReporter.failure(error).join('\n') })), TE.fromEither);
const readFile = (filename) => (0, function_1.pipe)((0, lerna_utils_1.readFile)(filename), TE.mapLeft((error) => err({ type: 'unable to read file', filename, error })));
const writeFile = (filename) => (contents) => (0, function_1.pipe)(contents, (0, trace_1.trace)(debug.cmd, `Writing file ${filename}`), (0, lerna_utils_1.writeFile)(filename), TE.mapLeft((error) => err({ type: 'unable to write file', filename, error })));
const updateDependencies = (packageJson) => (hoistedPackages) => {
    const withHoistedDependencies = (deps) => (0, function_1.pipe)(O.fromNullable(deps), O.map(R.reduceWithIndex({}, (pkg, acc, version) => Object.assign(acc, {
        [pkg]: O.getOrElse((0, function_1.constant)(version))(O.fromNullable(hoistedPackages.get(pkg))),
    }))), O.toUndefined);
    return (0, function_1.pipe)(readFile(packageJson), TE.chain((contents) => (0, function_1.pipe)((0, io_ts_1.StringifiedJSON)(io_ts_1.PackageJsonDependencies).decode(contents), E.map((originalJson) => (0, function_1.pipe)(originalJson, (0, shades_1.mod)('dependencies')(withHoistedDependencies), (0, shades_1.mod)('devDependencies')(withHoistedDependencies), (0, shades_1.mod)('optionalDependencies')(withHoistedDependencies), (0, shades_1.mod)('peerDependencies')(withHoistedDependencies), R.filter((value) => value !== undefined), (updatedJson) => (0, fast_deep_equal_1.default)(originalJson, updatedJson) ? O.none : O.some(updatedJson))), E.mapLeft((errors) => PathReporter.failure(errors).join('\n')), E.mapLeft((error) => err({ type: 'unable to parse file', filename: packageJson, error })), TE.fromEither)), TE.chain((updates) => (0, function_1.pipe)(updates, E.fromOption(() => err({ type: 'no-op' })), E.map((0, trace_1.trace)(debug.cmd, 'Updating file', packageJson)), E.chain((0, function_1.flow)((0, stringify_json_1.stringifyJSON)(E.toError), E.mapLeft((error) => err({ type: 'unable to stringify package.json', error })))), TE.fromEither, TE.chain((updates) => (0, function_1.pipe)(writeFile(packageJson)(updates), TE.mapLeft((error) => err({ type: 'unable to write file', filename: packageJson, error })))), TE.orElse((error) => (0, ts_pattern_1.match)(error)
        .with({ type: 'no-op' }, () => TE.of(undefined))
        .otherwise(() => TE.left(error))))));
};
const main = (0, function_1.pipe)(decodeDocopt(CommandLineOptions, docstring), TE.chain((options) => (0, function_1.pipe)((0, monorepo_root_1.monorepoRoot)(options.package), E.map((root) => ({ options, root })), TE.fromEither)), TE.chain(({ options, root }) => (0, function_1.pipe)((0, hoisted_packages_1.hoistedPackages)(root), TE.chain(updateDependencies(path.resolve(options.package, 'package.json'))))), TE.fold((0, function_1.flow)(Console.error, IO.chain(() => process.exit(1)), T.fromIO), (0, function_1.constant)(T.of(undefined))));
main();
//  LocalWords:  packageJson devDependencies optionalDependencies
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=use-hoisted-version.js.map